
//Copyright © 2016 Tristan Stephens(TDS200).

var vehicleBaseType = [];
var vehicleList = [];

var vehicleON = false;
var activeVehicle;
var activeVehicleID;
var activeVehicleSpeed;
var activeVehicleType;
var vehicleRecoveryTimer = 0;

function newLevel(){
 loadItems();
}

function useItem( x, y, z, id, b ){

  if(vehicleBaseType[id] != null){
   spawnVehicle( id, x, y, z);
  }

}

function attackHook(attacker, victim){

  for(i=0; i<vehicleList.length; i++){
    if(victim == vehicleList[i].mID){
	 actionCheck(victim,i);
	 break;
	}
  }

}

function deathHook(murderer, victim){
  for(i=0; i<vehicleList.length; i++){
    if(victim == vehicleList[i].mID){
	 vehicleList[i].isSpawned = false;
	 vehicleList[i].endFunction();
	 break;
	}
  }
}

function modTick(){

if(vehicleON == true){
vehicleMotor(activeVehicle,activeVehicleSpeed,activeVehicleType);
gasFunction(activeVehicleID);
vehicleList[activeVehicleID].tickFunction();
}

if(
vehicleON == false || 
getPlayerX() <  Entity.getX(activeVehicle) -2 || 
getPlayerX() >  Entity.getX(activeVehicle) +2 ||
getPlayerZ() <  Entity.getZ(activeVehicle) -2 || 
getPlayerZ() >  Entity.getZ(activeVehicle) +2 ){

if(activeVehicle != null){
setVelX(activeVehicle,0);
setVelY(activeVehicle,-0.5);
setVelZ(activeVehicle,0);
vehicleON = false;
vehicleList[activeVehicleID].endFunction();
}
}

vehicleRecoveryTimer ++;
if(vehicleRecoveryTimer == 40){
 loadVehicles();
}

if(getYaw() > 360 || getYaw() < -360){
setRot(getPlayerEnt(),0,getPitch());
}

}



function leaveGame(){
if(activeVehicle != null){
vehicleList[activeVehicleID].endFunction();
}
saveVehicles();
}
function actionCheck(mob,id){

if(getCarriedItem() == 1000 ){
preventDefault();
Entity.rideAnimal(getPlayerEnt(), mob);
activeVehicle = mob;
activeVehicleID = id;
activeVehicleSpeed = vehicleList[id].speed;
activeVehicleType = vehicleList[id].type;
vehicleON = true;
vehicleList[id].startFunction();
}

if(getCarriedItem() == 1001){
preventDefault();
vehicleList[id].gasAmount = 5000;
clientMessage(ChatColor.BLUE+"Fuel Level: [|||||||||||]");
}

if(getCarriedItem() != 1000 && getCarriedItem() != 1001){
Level.dropItem(Entity.getX(mob) , Entity.getY(mob) , Entity.getZ(mob) , 0 , vehicleList[id].id , 1 , 0);
Entity.remove(mob);
vehicleList[id].isSpawned = false;
}

}
function gasFunction(id){

vehicleList[id].gasAmount --;

if(vehicleList[id].gasAmount == 3750){
clientMessage(ChatColor.BLUE+"Fuel Level: [||||||||   ]");
}


if(vehicleList[id].gasAmount == 2500){
clientMessage(ChatColor.BLUE+"Fuel Level: [|||||     ]");
}


if(vehicleList[id].gasAmount == 1250){
clientMessage(ChatColor.RED+"Fuel Level: [|||       ]");
}


if(vehicleList[id].gasAmount == 0){
clientMessage(ChatColor.RED+"Out Of Fuel.");
}

if(vehicleList[id].gasAmount < 0 ){
vehicleON = false;
}

} 
 bulldozerModel = Renderer.createHumanoidRenderer();
 bulldozerModelMaker(bulldozerModel);
 blockNum = 0;
 
 //wooden plane
 vehicleBaseType[1101] = {
id: 1101,
type: "CAR",
skin: "mob/bulldozer.png",
health: 1000,
speed: 0.1,
model: bulldozerModel,
hitBox1: 2,
hitBox2: 1.5,
startFunction: function() {},
tickFunction: function() {plowFunction();},
endFunction: function() {},
loadItems: function() {bulldozerItems();}
};


function bulldozerItems(){

ModPE.setItem(1100 , "bulldozerPlow" , 0 , "Bulldozer Plow");
Item.setCategory(1100,3);
Player.addItemCreativeInv(1100, 1);
Item.addShapedRecipe(1100, 1 , 0 , ["idi","iii","iii"] , [ "i" , 265  , 0 , "d" , 351 , 11 ] );


ModPE.setItem(1101, "bulldozer" , 0 , "Bulldozer");
Item.setCategory(1101,3);
Player.addItemCreativeInv(1101, 1);
Item.addShapedRecipe(1101, 1 , 0 , [" p ","mbd","c c"] , [ "p", 1100, 0, "d" , 351  , 11 , "c" , 1011 , 0 , "b" , 1004 , 0 , "m" , 1002 , 0 ] );


}


function bulldozerModelMaker(variable){

var model = variable.getModel();

model.getPart("head").clear();
model.getPart("body").clear();
model.getPart("rightArm").clear();
model.getPart("leftArm").clear();
model.getPart("rightLeg").clear();
model.getPart("leftLeg").clear();

body = model.getPart("body");
body.setTextureSize(512,256);


body.setTextureOffset(0,235);
body.addBox(-19,13,-34,5,10,10);

body.setTextureOffset(0,235);
body.addBox(-19,13,3,5,10,10);

body.setTextureOffset(0,235);
body.addBox(13,13,3,5,10,10);

body.setTextureOffset(0,235);
body.addBox(13,13,-34,5,10,10);

body.setTextureOffset(0,180);
body.addBox(12,23,-35,8,1,50);

body.setTextureOffset(0,180);
body.addBox(-20,23,-35,8,1,50);

body.setTextureOffset(0,180);
body.addBox(12,12,-35,8,1,50);

body.setTextureOffset(0,180);
body.addBox(-20,12,-35,8,1,50);

body.setTextureOffset(369,169);
body.addBox(18,16,-30,1,4,39);

body.setTextureOffset(400,162);
body.addBox(13,13,-19,5,10,5);

body.setTextureOffset(400,161);
body.addBox(13,13,-8,5,10,5);

body.setTextureOffset(0,161);
body.addBox(12,12,-36,8,12,1);

body.setTextureOffset(0,161);
body.addBox(12,12,15,8,12,1);

body.setTextureOffset(0,161);
body.addBox(-20,12,-36,8,12,1);

body.setTextureOffset(0,161);
body.addBox(-20,12,15,8,12,1);

body.setTextureOffset(400,161);
body.addBox(-18,13,-8,5,10,5);

body.setTextureOffset(400,161);
body.addBox(-18,13,-19,5,10,5);

body.setTextureOffset(369,169);
body.addBox(-20,16,-30,1,4,39);

body.setTextureOffset(0,0);
body.addBox(-12,11,-40,24,8,58);

body.setTextureOffset(200,0);
body.addBox(-12,-2,-37,24,13,30);

body.setTextureOffset(316,0);
body.addBox(-16,-2,-7,4,13,25);

body.setTextureOffset(378,0);
body.addBox(12,-2,-7,4,13,25);

body.setTextureOffset(0,100);
body.addBox(-12,-2,17,24,13,1);

body.setTextureOffset(0,0);
body.addBox(13,-22,-6,2,20,2);

body.setTextureOffset(0,0);
body.addBox(-15,-22,-6,2,20,2);

body.setTextureOffset(0,0);
body.addBox(13,-22,15,2,20,2);

body.setTextureOffset(0,0);
body.addBox(-15,-22,15,2,20,2);

body.setTextureOffset(0,0);
body.addBox(-17,-24,-8,34,2,27);

body.setTextureOffset(400,200);
body.addBox(6,-18,-32,3,16,3);

body.setTextureOffset(400,200);
body.addBox(5.5,-23,-32.5,4,5,4);

body.setTextureOffset(0,0);
body.addBox(-21,3,-48,42,18,2);

body.setTextureOffset(0,0);
body.addBox(-22,3,-53,1,18,5);

body.setTextureOffset(0,0);
body.addBox(21,3,-53,1,18,5);

body.setTextureOffset(0,0);
body.addBox(-21,20,-55,42,1,7);

body.setTextureOffset(0,0);
body.addBox(12,6,-46,1,3,12);

body.setTextureOffset(0,0);
body.addBox(-13,6,-46,1,3,11);

}

function plowFunction(){

bulldozer = activeVehicle;


//is facing north?
if( getYaw() > -45 && getYaw() < 45 ){
northFacingBulldozer();
}

//is facing west?
if( getYaw() > 45 && getYaw() < 135 || getYaw() > -315 && getYaw() < -225){
westFacingBulldozer();
}

//is facing south?
if( getYaw() > 135 && getYaw() < 225 || getYaw() > -225 && getYaw() < -135 ){
southFacingBulldozer();
}

//is facing east?
if( getYaw() > 225 && getYaw() < 315 || getYaw() > -135 && getYaw() < -45 ){
eastFacingBulldozer();
}




function northFacingBulldozer(){

blockInFrontOfBulldozer1 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 2 );
blockInFrontOfBulldozer2 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 2 );
blockInFrontOfBulldozer3 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 2 );

blockInFrontOfBulldozer4 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 2 );
blockInFrontOfBulldozer5 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 2 );
blockInFrontOfBulldozer6 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 2 );

blockInFrontOfBulldozer7 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 2 );
blockInFrontOfBulldozer8 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 2 );
blockInFrontOfBulldozer9 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 2 );



blockToFillIn1 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 2 );
blockToFillIn2 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 2 );
blockToFillIn3 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 2 );

//layer 1

if(blockInFrontOfBulldozer1 != 0 && blockInFrontOfBulldozer1 != 1){
Level.dropItem(Entity.getX(bulldozer) + 1, Entity.getY(bulldozer) , Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer1 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 2,0,0);
       setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer2 != 0 && blockInFrontOfBulldozer2 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 0, Entity.getY(bulldozer) , Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer2 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 2,0,0);
       setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer3 != 0 && blockInFrontOfBulldozer3 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 1, Entity.getY(bulldozer) , Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer3 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 2,0,0);
       setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}



//layer 2


if(blockInFrontOfBulldozer4 != 0 && blockInFrontOfBulldozer4 != 1){
Level.dropItem(Entity.getX(bulldozer) + 1, Entity.getY(bulldozer) +1, Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer4 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 2,0,0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer5 != 0 && blockInFrontOfBulldozer5 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 0, Entity.getY(bulldozer) +1 , Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer5 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 2,0,0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer6 != 0 && blockInFrontOfBulldozer6 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 1, Entity.getY(bulldozer) +1, Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer6 , 1 , 0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 2,0,0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}



//layer 3


if(blockInFrontOfBulldozer7 != 0 && blockInFrontOfBulldozer7 != 1){
Level.dropItem(Entity.getX(bulldozer) + 1, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer7 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 2,0,0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer8 != 0 && blockInFrontOfBulldozer8 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 0, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer8 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 2,0,0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer9 != 0 && blockInFrontOfBulldozer9 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 1, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) + 2, 0 , blockInFrontOfBulldozer9 , 1 , 0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 2,0,0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}





if(blockToFillIn1 == 0 && blockNum > 0 || blockToFillIn1 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 2,13,0);
blockNum--;
}
if(blockToFillIn2 == 0 && blockNum > 0 || blockToFillIn2 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 2,13,0);
blockNum--;
}
if(blockToFillIn3 == 0 && blockNum > 0 || blockToFillIn3 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 2,13,0);
blockNum--;
}

}

 
 
 
 
 
 
 function southFacingBulldozer(){
 
blockInFrontOfBulldozer1 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
blockInFrontOfBulldozer2 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
blockInFrontOfBulldozer3 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
 
blockInFrontOfBulldozer4 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
blockInFrontOfBulldozer5 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
blockInFrontOfBulldozer6 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
 
blockInFrontOfBulldozer7 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
blockInFrontOfBulldozer8 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
blockInFrontOfBulldozer9 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
 
 
blockToFillIn1 = getTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 2,0,0);
blockToFillIn2 = getTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 2,0,0);
blockToFillIn3 = getTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 2,0,0);
 
 //layer 1

if(blockInFrontOfBulldozer1 != 0 && blockInFrontOfBulldozer1 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 1, Entity.getY(bulldozer) , Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer1 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
       setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
	   
}

if(blockInFrontOfBulldozer2 != 0 && blockInFrontOfBulldozer2 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 0, Entity.getY(bulldozer) , Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer2 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
       setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;   
}

if(blockInFrontOfBulldozer3 != 0 && blockInFrontOfBulldozer3 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 1, Entity.getY(bulldozer) , Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer3 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 2,0,0);
       setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}




//layer 2


if(blockInFrontOfBulldozer4 != 0 && blockInFrontOfBulldozer4 != 1){
Level.dropItem(Entity.getX(bulldozer) + 1, Entity.getY(bulldozer) +1, Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer4 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) - 2,0,0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer5 != 0 && blockInFrontOfBulldozer5 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 0, Entity.getY(bulldozer) +1 , Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer5 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) - 2,0,0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer6 != 0 && blockInFrontOfBulldozer6 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 1, Entity.getY(bulldozer) +1, Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer6 , 1 , 0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) - 2,0,0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}



//layer 3


if(blockInFrontOfBulldozer7 != 0 && blockInFrontOfBulldozer7 != 1){
Level.dropItem(Entity.getX(bulldozer) + 1, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer7 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) - 2,0,0);
        setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer8 != 0 && blockInFrontOfBulldozer8 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 0, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer8 , 1 , 0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) - 2,0,0);
        setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer9 != 0 && blockInFrontOfBulldozer9 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 1, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) - 2, 0 , blockInFrontOfBulldozer9 , 1 , 0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) - 2,0,0);
        setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) +2,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}







if(blockToFillIn1 == 0  && blockNum > 0 || blockToFillIn1 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 2,13,0);
blockNum--;
}
if(blockToFillIn2 == 0  && blockNum > 0 || blockToFillIn2 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) + 0,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 2,13,0);
blockNum--;
}
if(blockToFillIn3 == 0  && blockNum > 0 || blockToFillIn3 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 2,13,0);
blockNum--;
}



}






function eastFacingBulldozer(){

blockInFrontOfBulldozer1 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
blockInFrontOfBulldozer2 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
blockInFrontOfBulldozer3 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);

blockInFrontOfBulldozer4 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
blockInFrontOfBulldozer5 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
blockInFrontOfBulldozer6 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);

blockInFrontOfBulldozer7 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
blockInFrontOfBulldozer8 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
blockInFrontOfBulldozer9 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);

blockToFillIn1 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 1,0,0);
blockToFillIn2 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 0,0,0);
blockToFillIn3 = getTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 1,0,0);


//layer 1

if(blockInFrontOfBulldozer1 != 0 && blockInFrontOfBulldozer1 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer) , Entity.getZ(bulldozer) + 1, 0 , blockInFrontOfBulldozer1 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer2 != 0 && blockInFrontOfBulldozer2 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer) , Entity.getZ(bulldozer) + 0, 0 , blockInFrontOfBulldozer2 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer3 != 0 && blockInFrontOfBulldozer3 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer) , Entity.getZ(bulldozer) - 1, 0 , blockInFrontOfBulldozer3 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}


//layer 2

if(blockInFrontOfBulldozer4 != 0 && blockInFrontOfBulldozer4 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer) +1, Entity.getZ(bulldozer) + 1, 0 , blockInFrontOfBulldozer4 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer) +1,Entity.getZ(bulldozer) + 1,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer5 != 0 && blockInFrontOfBulldozer5 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer) +1, Entity.getZ(bulldozer) + 0, 0 , blockInFrontOfBulldozer5 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) + 0,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) + 0,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer6 != 0 && blockInFrontOfBulldozer6 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer)+1 , Entity.getZ(bulldozer) - 1, 0 , blockInFrontOfBulldozer6 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) - 1,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}


//layer 3

if(blockInFrontOfBulldozer7 != 0 && blockInFrontOfBulldozer7 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) + 1, 0 , blockInFrontOfBulldozer7 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 1,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer8 != 0 && blockInFrontOfBulldozer8 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer)+2 , Entity.getZ(bulldozer) + 0, 0 , blockInFrontOfBulldozer8 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 0,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 0,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer9 != 0 && blockInFrontOfBulldozer9 != 1 ){
Level.dropItem(Entity.getX(bulldozer) + 2, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) - 1, 0 , blockInFrontOfBulldozer9 , 1 , 0);
       setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) - 1,0,0);
	   setTile(Entity.getX(bulldozer) + 1,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}






if(blockToFillIn1 == 0  && blockNum > 0 || blockToFillIn1 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 1,13,0);
blockNum--;
}
if(blockToFillIn2 == 0  && blockNum > 0 || blockToFillIn2 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 0,13,0);
blockNum--;
}
if(blockToFillIn3 == 0  && blockNum > 0 || blockToFillIn3 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) + 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 1,13,0);
blockNum--;
}



}







function westFacingBulldozer(){

blockInFrontOfBulldozer1 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
blockInFrontOfBulldozer2 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
blockInFrontOfBulldozer3 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);

blockInFrontOfBulldozer4 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
blockInFrontOfBulldozer5 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
blockInFrontOfBulldozer6 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);

blockInFrontOfBulldozer7 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
blockInFrontOfBulldozer8 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
blockInFrontOfBulldozer9 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);



blockToFillIn1 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 1,0,0);
blockToFillIn2 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 0,0,0);
blockToFillIn3 = getTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 1,0,0);


//level 1

if(blockInFrontOfBulldozer1 != 0 && blockInFrontOfBulldozer1 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer) , Entity.getZ(bulldozer) + 1, 0 , blockInFrontOfBulldozer1 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer2 != 0 && blockInFrontOfBulldozer2 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer) , Entity.getZ(bulldozer) + 0, 0 , blockInFrontOfBulldozer2 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) + 0,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer3 != 0 && blockInFrontOfBulldozer3 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer) , Entity.getZ(bulldozer) - 1, 0 , blockInFrontOfBulldozer3 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer),Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}


//level 2

if(blockInFrontOfBulldozer4 != 0 && blockInFrontOfBulldozer4 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer) +1, Entity.getZ(bulldozer) + 1, 0 , blockInFrontOfBulldozer4 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) + 1,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer5 != 0 && blockInFrontOfBulldozer5 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer)+1 , Entity.getZ(bulldozer) + 0, 0 , blockInFrontOfBulldozer5 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) + 0,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) + 0,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer6 != 0 && blockInFrontOfBulldozer6 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer)+1 , Entity.getZ(bulldozer) - 1, 0 , blockInFrontOfBulldozer6 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) - 1,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer)+1,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}


//level 3

if(blockInFrontOfBulldozer7 != 0 && blockInFrontOfBulldozer7 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) + 1, 0 , blockInFrontOfBulldozer7 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 1,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 1,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer8 != 0 && blockInFrontOfBulldozer8 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer)+2 , Entity.getZ(bulldozer) + 0, 0 , blockInFrontOfBulldozer8 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 0,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) + 0,0,0);
	   blockNum++;
}

if(blockInFrontOfBulldozer9 != 0 && blockInFrontOfBulldozer9 != 1 ){
Level.dropItem(Entity.getX(bulldozer) - 2, Entity.getY(bulldozer) +2, Entity.getZ(bulldozer) - 1, 0 , blockInFrontOfBulldozer9 , 1 , 0);
       setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) - 1,0,0);
	   setTile(Entity.getX(bulldozer) - 1,Entity.getY(bulldozer)+2,Entity.getZ(bulldozer) - 1,0,0);
	   blockNum++;
}






if(blockToFillIn1 == 0  && blockNum > 0 || blockToFillIn1 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 1,13,0);
blockNum--;
}
if(blockToFillIn2 == 0  && blockNum > 0 || blockToFillIn2 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) + 0,13,0);
blockNum--;
}
if(blockToFillIn3 == 0  && blockNum > 0 || blockToFillIn3 == 31 && blockNum > 0){
setTile(Entity.getX(bulldozer) - 2,Entity.getY(bulldozer) -1,Entity.getZ(bulldozer) - 1,13,0);
blockNum--;
}

}





}

carModel = Renderer.createHumanoidRenderer(); 
 carModelMaker(carModel);
  
 //Spitfire
 vehicleBaseType[1120] = {
id: 1120,
type: "CAR",
skin: "mob/car.png",
health: 10000,
speed: 0.5,
model: carModel,
hitBox1: 2,
hitBox2: 0.7,
startFunction: function() {},
tickFunction: function() {},
endFunction: function() {},
loadItems: function() {carItems();}
};


function carItems(){

ModPE.setItem(1120 , "car" , 0 , "Red Car");
Item.setCategory(1120,3);
Player.addItemCreativeInv(1120, 1);
Item.addShapedRecipe(1120, 1 , 0 , ["mcr","w w","w w"] , [ "w" , 1003  , 0 , "m" , 1002 , 0 , "r" , 351 , 1 , "c" , 1004 , 0 ]  );
}

function carModelMaker(variable) {

var model = variable.getModel();


model.getPart("head").clear();
model.getPart("body").clear();
model.getPart("rightArm").clear();
model.getPart("leftArm").clear();
model.getPart("rightLeg").clear();
model.getPart("leftLeg").clear();



body = model.getPart("body");

body.setTextureSize(64,64);

body.addBox(-14.0, 4.0,-26.0 , 14, 15, 1);
body.addBox( 0.0,4.0 ,-26.0 , 14,15 ,1 );
body.setTextureOffset(31,48);
body.addBox( 0.0, 16.0,-27.0 , 14,3 ,1);
body.addBox( -14.0,16.0 ,-27.0 , 14,3 ,1 );
body.addBox( 7.5,12.0 ,-26.5 ,4 ,2 , 1);
body.setTextureOffset(0,30);
body.addBox(11.5 , 10.0,-26.5 ,3 , 4, 1);
body.setTextureOffset(15,30);
body.addBox( 7.5,10.0 ,-26.5 , 4, 2, 1);
body.setTextureOffset(0,30);
body.addBox(-14.5,10.0 ,-26.5 ,3,4 , 1);
body.setTextureOffset(31,48);
body.addBox(-11.5 , 12.0, -26.5, 4, 2, 1);
body.setTextureOffset(15,30);
body.addBox(-11.5 , 10.0, -26.5, 4, 2,1 );
body.setTextureOffset(31,48);
body.addBox( 0.3, 7.0, -26.3, 14, 1, 1);
body.addBox(-14.3 ,7.0 ,-26.3 ,14 , 1, 1);
body.addBox( -1.0, 6.0,-27.0 ,2 , 3, 1);
body.setTextureOffset(0,0);
body.addBox( -14.0, 4.0,-25.0 , 1,15 , 6);
body.setTextureOffset(31,48);
body.addBox( -15.0,16.0 ,-27.0 , 1,3 , 6);
body.addBox( -14.3,7.0 , -25.7, 1, 1, 15);
body.setTextureOffset(0,0);
body.addBox(13.0 , 4.0,-25.0 , 1, 15, 6);
body.setTextureOffset(31,48);
body.addBox( 14.0, 16.0,-27.0 , 1, 3, 6);
body.addBox( 13.3,7.0 ,-26.0 ,1 ,1 , 15);
body.setTextureOffset(0,0);
body.addBox(-13.0 ,3.0 ,-25.0 ,13 , 1, 19);
body.addBox( 0.0, 3.0,-25.0 , 13,1 , 19);
body.addBox(-14.0 ,4.0 , -19.0,1 , 10, 9);
body.addBox( 13.0, 4.0, -19.0, 1,10 , 9);
body.addBox( -14.0,4.0 ,-10.0 , 1,15 , 6);
body.addBox( 13.0, 4.0,-10.0 ,1 ,15 , 6);
body.addBox( -14.0, 4.0, -4.0,1 , 15, 15);
body.setTextureOffset(31,48);
body.addBox(-14.3 ,7.0 ,-11.0 , 1, 1, 7);
body.addBox( -14.3, 7.0, -3.0,1 ,1 , 13);
body.addBox( -15.0,9.0 ,6.0 , 1, 1, 3);
body.addBox( 14.0,9.0 , 6.0, 1,1 , 3);
body.setTextureOffset(0,0);
body.addBox( 13.0,4.0 , -4.0, 1,15 ,15 );
body.setTextureOffset(31,48);
body.addBox( 13.3,7.0 ,-3.0 ,1 , 1,13 );
body.addBox( 13.3, 7.0,-11.0 , 1, 1, 7);
body.addBox( -1.0, 4.0,-7.0 ,14 , 15, 1);
body.addBox( -13.0,4.0 , -7.0,12,15 , 1);
body.setTextureOffset(0,0);
body.addBox(0.0, 18.0,-6.0 ,13 ,1 ,17 );
body.addBox( -13.0,18.0 , -6.0, 13,1 ,17 );
body.addBox(0.0 ,18.0 ,11.0 ,13 ,1 ,15 );
body.addBox( -13.0, 18.0, 11.0,13 ,1 ,15 );
body.addBox(13.0 ,4.0 ,11.0 ,1 ,15 , 15);
body.addBox( -14.0, 4.0, 11.0, 1,15 ,15 );
body.setTextureOffset(31,48);
body.addBox( 1.0, 4.0, 25.0, 12,14 , 1);
body.addBox( -13.0, 4.0,25.0 , 14,14 , 1);
body.addBox(13.3 , 7.0, 12.0, 1,1 , 13);
body.addBox( 14.0, 9.0, 21.0, 1,1 , 3);
body.addBox( -14.3, 7.0, 12.0, 1,1 ,13 );
body.addBox(-15.0 , 9.0, 21.0, 1,1 ,3 );
body.setTextureOffset(0,0);
body.addBox( -14.0,4.0 , 26.0, 1, 15, 4);
body.addBox( 13.0,4.0 , 26.0, 1,15 , 3);
body.addBox( 13.0, 4.0,29.0 ,1 ,10 , 9);
body.addBox( 13.0, 4.0, 38.0,1 ,15 ,6 );
body.addBox(-14.0 ,4.0 ,30.0 ,1 ,10 , 9);
body.addBox( -14.0, 4.0,39.0 , 1,15 , 6);
body.addBox( 0.0,4.0 ,44.0 ,14 ,15 , 1);
body.addBox( -14.0,4.0 ,44.0 , 14,15 ,1 );
body.addBox( 0.0,3.0 ,25.0 ,13 , 1, 19);
body.addBox( -13.0,3.0 ,25.0 ,13 ,1 , 19);
body.addBox( 0.0,-10.0 , 0.0,13 , 1,19 );
body.addBox( -13.0,-10.0 ,0.0 ,13 ,1 , 19);
body.addBox( -13.0,0.0 , -8.0,2 , 3,2 );
body.addBox( -13.0, -3.0, -6.0,2 ,3 ,2 );
body.addBox( -13.0, -6.0, -4.0,2 ,3 , 2);
body.addBox( -13.0, -9.0, -2.0, 2, 3,2 );
body.addBox( 11.0, 0.0, -8.0, 2, 3, 2);
body.addBox( 11.0, -3.0,-6.0, 2, 3,2 );
body.addBox( 11.0,-6.0 , -4.0, 2,3 ,2 );
body.addBox( 11.0, -9.0,-2.0 , 2, 3,2 );
body.addBox( 11.0,0.0 ,25.0 ,2 ,3 ,2 );
body.addBox(11.0 , -3.0,23.0 , 2,3 ,2 );
body.addBox(11.0 ,-6.0 , 21.0, 2,3 ,2 );
body.addBox( 11.0,-9.0 , 19.0, 2,3 , 2);
body.addBox( -13.0,0.0 ,25.0 , 2,3 , 2);
body.addBox(-13.0 , -3.0,23.0 , 2,3 ,2 );
body.addBox(-13.0 ,-6.0 ,21.0 , 2, 3,2 );
body.addBox(-13.0 , -9.0,19.0 , 2, 3, 2);
body.setTextureOffset(31,48);
body.addBox(13.3 , 7.0, 27.0,1 , 1,15 );
body.addBox(13.3 , 7.0,42.0 ,1 ,1 ,3 );
body.addBox(-14.3,7.0 , 27.0,1 ,1 , 15);
body.addBox( -14.3,7.0 ,42.0 ,1 , 1, 3);
body.addBox( 0.3, 7.0, 44.3,14 ,1 , 1);
body.addBox( -14.3, 7.0, 44.3, 14, 1, 1);
body.addBox(-1.0 ,6.0 ,45.0 ,2 ,3 ,1 );
body.addBox( 14.0,16.0 ,40.0 , 1, 3, 6);
body.addBox( 0.0, 16.0, 45.0, 14, 3, 1);
body.addBox(-14.0 , 16.0, 45.0, 14,3 , 1);
body.addBox( -15.0,16.0 ,40.0 ,1 ,3 ,6 );
body.setTextureOffset(17,33);
body.addBox( 7.0, 10.0, 45.0, 5,3 , 1);
body.addBox( -12.0,10.0 ,45.0 ,5 , 3, 1);
body.setTextureOffset(0,48);
body.addBox( 11.0, 15.0, -18.0,4 ,7 ,7 );
body.addBox( -15.0, 15.0,-18.0 ,4 , 7,7 );
body.addBox( -15.0,15.0 ,31.0 ,4 , 7, 7);
body.addBox( 11.0,15.0 , 30.0, 4, 7,7 );

}
 spitfireModel = Renderer.createHumanoidRenderer(); 
 spitfireModelMaker(spitfireModel);
  
 //Spitfire
 vehicleBaseType[1150] = {
id: 1150,
type: "AIRCRAFT",
skin: "mob/spitfire.png",
health: 10000,
speed: 0.8,
model: spitfireModel,
hitBox1: 2,
hitBox2: 1.4,
startFunction: function() {loadFireButton();},
tickFunction: function() {},
endFunction: function() {destroyFireButton();},
loadItems: function() {spitfireItems();}
};


function spitfireItems(){

ModPE.setItem(1150 , "spitfire" , 0 , "Spitfire");
Item.setCategory(1150,3);
Player.addItemCreativeInv(1150, 1);
Item.addShapedRecipe(1150, 1 , 0 , ["pm ","wcw"," tb"] , [ "b", 1017, 0, "p", 1016, 0, "c" , 1008 , 0 , "t" , 1009 , 0 , "m" , 1002 , 0 , "w" , 1010 , 0] ); // tail

}

function spitfireModelMaker(variable) {

var model = variable.getModel();

// gets the head
model.getPart("head").clear();
// gets the body
var body = model.getPart("body").clear();
// gets the right arm
model.getPart("rightArm").clear();
// gets the left arm
model.getPart("leftArm").clear();
// gets the right leg and removes it 
model.getPart("rightLeg").clear();
// gets the left leg and removes it
model.getPart("leftLeg").clear();

body.setTextureSize(256,128);


body.setTextureOffset(0,0);
body.addBox(-5,-1,-65,10,10,3);

body.setTextureOffset(22,0);
body.addBox(-6,-2,-62,12,12,3);

body.setTextureOffset(44,0);
body.addBox(-7,-3,-59,14,14,3);

body.setTextureOffset(0,0);
body.addBox(-8,-4,-56,16,16,3);

body.setTextureOffset(25,0);
body.addBox(-9,-5,-53,18,18,3);

body.setTextureOffset(23,0);
body.addBox(-10,-7,-50,20,23,34);

body.setTextureOffset(0,102);
body.addBox(-2,2,-69,4,4,4);

body.setTextureOffset(0,100);
body.addBox(-1,3,-70,2,2,1);

body.setTextureOffset(39,112);
body.addBox(2,3,-68,11,2,1);

body.setTextureOffset(41,119);
body.addBox(-13,3,-68,11,2,1);

body.setTextureOffset(0,116);
body.addBox(-1,-9,-68,2,11,1);

body.setTextureOffset(7,116);
body.addBox(-1,6,-68,2,11,1);

body.setTextureOffset(86,95);
body.addBox(10,5,-43,55,3,30);

body.setTextureOffset(86,62);
body.addBox(-65,5,-43,55,3,30);

body.setTextureOffset(0,0);
body.addBox(-10,14,-16,20,1,30);

body.setTextureOffset(194,0);
body.addBox(9,-5,-16,1,19,30);

body.setTextureOffset(131,0);
body.addBox(-10,-5,-16,1,19,30);

body.setTextureOffset(25,0);
body.addBox(-10,-20,14,20,34,20);

body.setTextureOffset(0,0);
body.addBox(7,-18,-19,2,11,2);

body.setTextureOffset(0,0);
body.addBox(-9,-18,-19,2,11,2);

body.setTextureOffset(0,0);
body.addBox(-10,-20,-6,20,1,20);

body.setTextureOffset(0,0);
body.addBox(-10,-19,-21,20,1,16);

body.setTextureOffset(3,11);
body.addBox(-9,-13,34,18,26,20);

body.setTextureOffset(25,7);
body.addBox(-8,-7,54,16,19,20);

body.setTextureOffset(25,0);
body.addBox(-7,-3,73,14,14,31);

body.setTextureOffset(0,60);
body.addBox(-3,20,90,2,4,4);

body.setTextureOffset(1,0);
body.addBox(-25.333333333333,3,84,50,3,20);

body.setTextureOffset(33,63);
body.addBox(-2,-23.266666666667,84.533333333333,4,20,19);

body.setTextureOffset(0,0);
body.addBox(-9,16,-40,2,6,2);

body.setTextureOffset(0,0);
body.addBox(7,16,-40,2,6,2);

body.setTextureOffset(0,60);
body.addBox(-11,20,-41,2,4,4);

body.setTextureOffset(0,60);
body.addBox(9,20,-41,2,4,4);

body.setTextureOffset(0,0);
body.addBox(-1,11,91,2,11,2);

body.setTextureOffset(0,60);
body.addBox(1,20,90,2,4,4);

body.setTextureOffset(0,100);
body.addBox(40,8,-40,4,4,8);

body.setTextureOffset(0,100);
body.addBox(-45,8,-40,4,4,8);

body.setTextureOffset(0,98);
body.addBox(41,9,-53,2,2,13);

body.setTextureOffset(0,98);
body.addBox(-44,9,-53,2,2,13);

body.setTextureOffset(0,85);
body.addBox(-44.5,8.5,-58,3,3,5);

body.setTextureOffset(0,85);
body.addBox(40,8.5,-58,3,3,5);

}
 tankModel = Renderer.createHumanoidRenderer(); 
 tankModelMaker(tankModel);
  
 //Spitfire
 vehicleBaseType[1140] = {
id: 1140,
type: "CAR",
skin: "mob/tank.png",
health: 10000,
speed: 0.3,
model: tankModel,
hitBox1: 2,
hitBox2: 1,
startFunction: function() {loadTankGUI();},
tickFunction: function() {},
endFunction: function() {destroyTankGUI();},
loadItems: function() {tankItems();}
};


function tankItems(){

ModPE.setItem(1140 , "tank" , 0 , "Tank");
Item.setCategory(1140,3);
Player.addItemCreativeInv(1140, 1);
Item.addShapedRecipe(1140, 1 , 0 , [" t ","mbd","c c"] , [ "d" , 351  , 2 , "c" , 1011 , 0 , "b" , 1012 , 0 , "m" , 1002 , 0 ] );

}

function tankModelMaker(variable) {

var model = variable.getModel();

model.getPart("head").clear();
model.getPart("body").clear();
model.getPart("rightArm").clear();
model.getPart("leftArm").clear();
model.getPart("rightLeg").clear();
model.getPart("leftLeg").clear();

body = model.getPart("body");

body.setTextureSize(512,256);

             //   l/r  u/d  F/B   w    h    l
 
body.setTextureOffset(201,0);
body.addBox(21,17,-21,3,6,6);

body.setTextureOffset(201,0);
body.addBox(21,17,-11.6,3,6,6);

body.setTextureOffset(201,0);
body.addBox(21,17,-3,3,6,6);

body.setTextureOffset(201,0);
body.addBox(21,17,6,3,6,6);

body.setTextureOffset(201,0);
body.addBox(21,17,15,3,6,6);

body.setTextureOffset(201,0);
body.addBox(-24,17,-2,3,6,6);

body.setTextureOffset(201,0);
body.addBox(-24,17,7,3,6,6);

body.setTextureOffset(201,0);
body.addBox(-24,17,16,3,6,6);

body.setTextureOffset(201,0);
body.addBox(-24,17,-11,3,6,6);

body.setTextureOffset(201,0);
body.addBox(-24,17,-20,3,6,6);

body.setTextureOffset(201,0);
body.addBox(21,13,-29,3,6,6);

body.setTextureOffset(201,0);
body.addBox(21,13,23,3,6,6);

body.setTextureOffset(201,0);
body.addBox(-24,13,-28,3,6,6);

body.setTextureOffset(201,0);
body.addBox(-24,13,24,3,6,6);

body.setTextureOffset(0,200);
body.addBox(20,23,-23,5,1,46);

body.setTextureOffset(0,200);
body.addBox(-25,23,-22,5,1,46);

body.setTextureOffset(0,200);
body.addBox(-25,22,-24,5,1,2);

body.setTextureOffset(0,200);
body.addBox(-25,21,-26,5,1,2);

body.setTextureOffset(0,200);
body.addBox(-25,20,-28,5,1,2);

body.setTextureOffset(0,200);
body.addBox(-25,13,-29,5,7,1);

body.setTextureOffset(0,200);
body.addBox(-25,22,24,5,1,2);

body.setTextureOffset(0,200);
body.addBox(-25,21,26,5,1,2);

body.setTextureOffset(0,200);
body.addBox(-25,20,28,5,1,2);

body.setTextureOffset(0,200);
body.addBox(-25,13,30,5,7,1);

body.setTextureOffset(0,200);
body.addBox(20,22,-25,5,1,2);

body.setTextureOffset(0,200);
body.addBox(20,21,-27,5,1,2);

body.setTextureOffset(0,200);
body.addBox(20,20,-29,5,1,2);

body.setTextureOffset(0,200);
body.addBox(20,12,-30,5,8,1);

body.setTextureOffset(0,200);
body.addBox(20,22,23,5,1,2);

body.setTextureOffset(0,200);
body.addBox(20,21,25,5,1,2);

body.setTextureOffset(0,200);
body.addBox(20,20,27,5,1,2);

body.setTextureOffset(0,200);
body.addBox(20,12,29,5,8,1);

body.setTextureOffset(0,0);
body.addBox(25,12,-31,1,5,66);

body.setTextureOffset(0,200);
body.addBox(20,18,-20,1,4,40);

body.setTextureOffset(0,200);
body.addBox(-21,18,-19,1,4,40);

body.setTextureOffset(0,0);
body.addBox(-26,12,-32,1,5,67);

body.setTextureOffset(0,0);
body.addBox(19,12,-32,7,5,1);

body.setTextureOffset(0,190);
body.addBox(20,11,-31,5,1,60);

body.setTextureOffset(0,190);
body.addBox(-25,11,-31,5,1,60);

body.setTextureOffset(0,0);
body.addBox(-25,12,-32,6,5,1);

body.setTextureOffset(0,0);
body.addBox(-20,12,-24,41,5,5);

body.setTextureOffset(0,0);
body.addBox(-20,12,-31,1,5,7);

body.setTextureOffset(0,0);
body.addBox(19,12,-31,1,5,7);

body.setTextureOffset(0,0);
body.addBox(-20,9,-19,40,3,48);

body.setTextureOffset(0,190);
body.addBox(-19,14,-29,40,2,5);

body.setTextureOffset(0,0);
body.addBox(-26,12,35,52,5,1);

body.setTextureOffset(0,0);
body.addBox(-26,8,29,52,4,7);

body.setTextureOffset(0,0);
body.addBox(-10,8,-7,21,1,21);

body.setTextureOffset(0,0);
body.addBox(-14,1,-17,28,7,43);

body.setTextureOffset(0,0);
body.addBox(-15,2,-16,1,5,41);

body.setTextureOffset(0,0);
body.addBox(14,2,-16,1,5,41);

body.setTextureOffset(0,0);
body.addBox(-13,2,26,26,5,1);

body.setTextureOffset(0,190);
body.addBox(-25,7,30,50,1,5);

body.setTextureOffset(0,0);
body.addBox(-13,0,-16,26,1,41);

body.setTextureOffset(0,0);
body.addBox(-13,2,-18,26,5,1);

body.setTextureOffset(0,134);
body.addBox(-7,-1,7,14,1,14);

body.setTextureOffset(0,0);
body.addBox(-6,-2,5,1,2,3);

body.setTextureOffset(0,0);
body.addBox(5,-2,5,1,2,3);

body.setTextureOffset(121,134);
body.addBox(-6,-0.5,-8,12,1,12);

body.setTextureOffset(131,120);
body.addBox(-8,-1,4,16,1,2);

body.setTextureOffset(131,120);
body.addBox(-8,-1,-10,16,1,2);

body.setTextureOffset(131,150);
body.addBox(-8,-1,-8,2,1,12);

body.setTextureOffset(131,150);
body.addBox(6,-1,-8,2,1,12);

body.setTextureOffset(0,194);
body.addBox(0,3,-68,4,4,50);

body.setTextureOffset(74,132);
body.addBox(-1,2,-76,6,6,10);

body.setTextureOffset(0,210);
body.addBox(-11,-19,22,1,19,1);

body.setTextureOffset(0,210);
body.addBox(-11.5,-22,21.5,2,3,2);
}


function loadTankGUI(){

var ctx=com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

AimOn = 0;
StartFov=1;

ctx.runOnUiThread(new java.lang.Runnable({

run:function(){

var ctx=com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

var layout=new android.widget.LinearLayout(ctx);
var layout2=new android.widget.LinearLayout(ctx);
layout2.setOrientation(android.widget.LinearLayout.VERTICAL);


var display=new android.util.DisplayMetrics();

w = ctx.getResources().getDisplayMetrics().widthPixels;
h = ctx.getResources().getDisplayMetrics().heightPixels;

window = new android.widget.PopupWindow();

btnWindow=new android.widget.PopupWindow(ctx);
btnWindow.setWidth(dip2px(ctx,100));//61
btnWindow.setHeight(dip2px(ctx,150));

btnWindow.setContentView(layout2);

btnWindow.setBackgroundDrawable(new android.graphics.drawable.ColorDrawable(android.graphics.Color.TRANSPARENT));
btnWindow.showAtLocation(ctx.getWindow().getDecorView(),android.view.Gravity.RIGHT|android.view.Gravity.TOP,0,-50);

iWindow=new android.widget.PopupWindow(ctx);
iWindow.setWidth(dip2px(ctx,100));//61
iWindow.setHeight(dip2px(ctx,100));

iWindow.setContentView(layout);

iWindow.setBackgroundDrawable(new android.graphics.drawable.ColorDrawable(android.graphics.Color.TRANSPARENT));
iWindow.showAtLocation(ctx.getWindow().getDecorView(),android.view.Gravity.CENTER|android.view.Gravity.CENTER,45,50);

var Img=new android.widget.ImageView(ctx);

if(Img.getParent() != null)
 Img.getParent().removeView(Img);

var tankd = android.os.Environment.getExternalStorageDirectory();

var pic=new android.graphics.drawable.BitmapDrawable(tankd + "/Android/data/net.zhuoweizhang.mcpelauncher.pro/files/textures/images/Scope.png");

var Text = new android.widget.TextView(ctx);
Text.setText("");

layout2.addView(Text);

Img.setBackgroundDrawable(pic);

layout.addView(Img);

var firebtn=new android.widget.Button(ctx);
firebtn.setText("Fire");
firebtn.getBackground().setColorFilter(android.graphics.Color.RED,android.graphics.PorterDuff.Mode.MULTIPLY);
firebtn.setOnClickListener(new android.view.View.OnClickListener({

onClick:function(){

shootMissle();

}}));


layout2.addView(firebtn);

}}));



function dip2px(ctx, dips){
    return Math.ceil(dips * ctx.getResources().getDisplayMetrics().density);
}


function shootMissle(){

    velY = Math.sin((getPitch() - 180) / 180 * Math.PI); 
    velX = 3.5 * (Math.sin(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI)); 
    velZ = 3.5 * (-1 * Math.cos(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI)); 
	
    bullet = Level.spawnMob(Player.getX() + Math.sin(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI) ,Player.getY()+1,Player.getZ() + -1 * Math.cos(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI) ,65);
      
    setVelX(bullet,velX*1.2); 
    setVelY(bullet,velY*1.2); 
    setVelZ(bullet,velZ*1.2);

}


}



function destroyTankGUI(){

var ctx=com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

ctx.runOnUiThread(new java.lang.Runnable({

run:function(){

var ctx=com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

if(iWindow !== null)
 iWindow.dismiss();

if(btnWindow !== null)
 btnWindow.dismiss();

}}));
} 
 woodenPlaneModel = Renderer.createHumanoidRenderer();
 woodenPlaneModelMaker(woodenPlaneModel);
 
 //wooden plane
 vehicleBaseType[1130] = {
id: 1130,
type: "AIRCRAFT",
skin: "mob/woodenplane.png",
health: 1000,
speed: 0.5,
model: woodenPlaneModel,
hitBox1: 2,
hitBox2: 0.7,
startFunction: function() {},
tickFunction: function() {},
endFunction: function() {},
loadItems: function() {woodenPlaneItems();}
};


function woodenPlaneItems(){

ModPE.setItem(1130 , "Biplane" , 0 , "Biplane");
Item.setCategory(1130,3);
Player.addItemCreativeInv(1130, 1);
Item.addShapedRecipe(1130, 1 , 0 , ["pm ","wcw"," t "] , [ "p", 1015, 0, "c" , 1006 , 0 , "t" , 1005 , 0 , "m" , 1002 , 0 , "w" , 1007 , 0] ); // w plane 

}


function woodenPlaneModelMaker(variable){

var model = variable.getModel();

model.getPart("head").clear();
model.getPart("body").clear();
model.getPart("rightArm").clear();
model.getPart("leftArm").clear();
model.getPart("rightLeg").clear();
model.getPart("leftLeg").clear();

var body = model.getPart("body");

body.setTextureSize(512,256);    
	//   x    y    F/B   x   y   F/B
 

body.setTextureOffset(0,0);
body.addBox(-10,14,-16,20,1,30);

body.setTextureOffset(0,0);
body.addBox(-10,5,-16,1,9,30);

body.setTextureOffset(0,0);
body.addBox(9,5,-16,1,9,30);

body.setTextureOffset(0,0);
body.addBox(-9,5,-16,18,9,1);

body.setTextureOffset(0,0);
body.addBox(-9,5,13,18,9,1);

body.setTextureOffset(0,0);
body.addBox(-40,6,-15,30,3,20);

body.setTextureOffset(0,0);
body.addBox(10,6,-15,30,3,20);

body.setTextureOffset(29,200);
body.addBox(-2,8,-20,4,4,4);

body.setTextureOffset(0,201);
body.addBox(8,20,-14,2,4,4);

body.setTextureOffset(0,201);
body.addBox(-10,20,-14,2,4,4);

body.setTextureOffset(0,0);
body.addBox(-8,17.466666666667,-13,1,5,2);

body.setTextureOffset(0,0);
body.addBox(-8,15,-16,16,3,30);

body.setTextureOffset(0,0);
body.addBox(7,17,-13,1,5,2);

body.setTextureOffset(0,0);
body.addBox(-40,-14,-15,80,3,20);

body.setTextureOffset(0,0);
body.addBox(-35,-11,-13,3,17,2);

body.setTextureOffset(0,0);
body.addBox(-35,-11,1,3,17,2);

body.setTextureOffset(0,0);
body.addBox(32,-11,-13,3,17,2);

body.setTextureOffset(0,0);
body.addBox(32,-11,1,3,17,2);

body.setTextureOffset(0,0);
body.addBox(-18,-11,-13,3,17,2);

body.setTextureOffset(0,0);
body.addBox(-18,-11,2,3,17,2);

body.setTextureOffset(0,0);
body.addBox(15,-11,2,3,17,2);

body.setTextureOffset(0,0);
body.addBox(15,-11,-13,3,17,2);

body.setTextureOffset(0,0);
body.addBox(-1.5,0,-19,3,8,1);

body.setTextureOffset(0,0);
body.addBox(-1.5,12,-19,3,8,1);

body.setTextureOffset(0,0);
body.addBox(2,8.5,-19,8,3,1);

body.setTextureOffset(0,0);
body.addBox(-10,8.5,-19,8,3,1);

body.setTextureOffset(0,0);
body.addBox(-7,7,14,14,9,27);

body.setTextureOffset(0,0);
body.addBox(-20,10,30,40,3,10);

body.setTextureOffset(0,0);
body.addBox(-1.5,-6,31,3,13,10);

}


function spawnVehicle( id, x, y, z){

entity = Level.spawnMob(x,y+1,z,15);

Entity.setMobSkin(entity, vehicleBaseType[id].skin);

Entity.setRenderType(entity ,  vehicleBaseType[id].model.renderType);

Entity.setHealth(entity , vehicleBaseType[id].health);

Entity.setCollisionSize(entity,vehicleBaseType[id].hitBox1,vehicleBaseType[id].hitBox2); 

Player.addItemInventory(vehicleBaseType[id].id,-1,0);


vehicleList[vehicleList.length] = {
id: id, 
mID: entity, 
type: vehicleBaseType[id].type , 
skin: vehicleBaseType[id].skin, 
health: vehicleBaseType[id].health, 
speed: vehicleBaseType[id].speed ,
model: vehicleBaseType[id].model,
gasAmount: 1,
startFunction: vehicleBaseType[id].startFunction,
tickFunction: vehicleBaseType[id].tickFunction,
endFunction: vehicleBaseType[id].endFunction,
isSpawned: true
};
}



function vehicleMotor( ent, speed, type){

var DEG_TO_RAD = Math.PI / 180;
var playerDir = [0, 0, 0];

playerDir[0] = Math.cos((getYaw() + 90) * DEG_TO_RAD ) * Math.cos(getPitch() * DEG_TO_RAD * -1);
playerDir[1] = Math.sin(getPitch() * DEG_TO_RAD * -1);
playerDir[2] = Math.sin((getYaw() + 90) * DEG_TO_RAD ) * Math.cos(getPitch() * DEG_TO_RAD * -1);

setRot(ent , getYaw() , 45 );


if(type == "AIRCRAFT"){

if(getPitch() > 3){
playerDir[1] = -0.3;
}

if(getPitch() < -3){
playerDir[1] = 0.3;
}

setVelX(ent, speed * playerDir[0]);
setVelY(ent, speed * playerDir[1]);
setVelZ(ent, speed * playerDir[2]);
}

/*
if(type == "BOAT"){
setVelX(ent, speed * playerDir[0]);
setVelZ(ent, speed * playerDir[2]);

boatblockup = getTile(Entity.getX(ent),Entity.getY(ent) + 1,Entity.getZ(ent));

if(boatblockup != 8){
vehicleON = false;
}
}
*/

if(type == "CAR"){
setVelX(ent, speed * playerDir[0]);
setVelZ(ent, speed * playerDir[2]);

var carblock = getTile(Entity.getX(ent),Entity.getY(ent) + 1,Entity.getZ(ent));

//is facing east?
if( getYaw() > -45 && getYaw() < 45 ){
var carblockfront = getTile(Entity.getX(ent),Entity.getY(ent),Entity.getZ(ent) +2);
var carblockup = getTile(Entity.getX(ent),Entity.getY(ent) +1,Entity.getZ(ent) +2);
}

//is facing west?
if( getYaw() > 135 && getYaw() < 225 || getYaw() > -225 && getYaw() < -135 ){
var carblockfront = getTile(Entity.getX(ent),Entity.getY(ent),Entity.getZ(ent) -2);
var carblockup = getTile(Entity.getX(ent),Entity.getY(ent) +1,Entity.getZ(ent) -2);
}


//is facing south?
if( getYaw() > 45 && getYaw() < 135 || getYaw() > -315 && getYaw() < -225){
var carblockfront = getTile(Entity.getX(ent) -2,Entity.getY(ent),Entity.getZ(ent));
var carblockup = getTile(Entity.getX(ent) -2,Entity.getY(ent) +1,Entity.getZ(ent));
}


//is facing north?
if( getYaw() > 225 && getYaw() < 315 || getYaw() > -135 && getYaw() < -45 ){
var carblockfront = getTile(Entity.getX(ent) +2,Entity.getY(ent),Entity.getZ(ent));
var carblockup = getTile(Entity.getX(ent) +2,Entity.getY(ent) +1,Entity.getZ(ent));
}


if(carblockup == 0 && carblockfront != 0 && carblockfront != 31  && carblockfront != 9) {
setVelY(ent, 0.3);
}

if(carblockup == 9){
vehicleON = false;
}


}


}
function saveVehicles(){

total = 0;

   for(i=0; i<vehicleList.length; i++){
   if(vehicleList[i] != null){
      if(vehicleList[i].isSpawned == true){
	   
       ModPE.saveData("vIDS" + i, vehicleList[i].id );
	   ModPE.saveData("mIDS" + i, vehicleList[i].mID);
	   ModPE.saveData("gasS" + i, vehicleList[i].gasAmount);
	   total ++;
     }
   }
  }
  
     ModPE.saveData("total", total);

  }

function loadVehicles(){

total = ModPE.readData("total");


for(i=0; i<total; i++){

 mobID = ModPE.readData("mIDS" + i);
 id = ModPE.readData("vIDS" + i);
 gas = ModPE.readData("gasS" + i);


Entity.setMobSkin( Number(mobID) , vehicleBaseType[id].skin);

Entity.setRenderType( Number(mobID) ,  vehicleBaseType[id].model.renderType);


vehicleList[vehicleList.length] = {
id: id, 
mID: mobID, 
type: vehicleBaseType[id].type , 
skin: vehicleBaseType[id].skin, 
health: vehicleBaseType[id].health, 
speed: vehicleBaseType[id].speed ,
model: vehicleBaseType[id].model,
gasAmount: gas,
startFunction: vehicleBaseType[id].startFunction,
tickFunction: vehicleBaseType[id].tickFunction,
endFunction: vehicleBaseType[id].endFunction,
isSpawned: true
};

}

}

function fireGun(id){

   if(id != 65){

    velY = Math.sin((getPitch() - 180) / 180 * Math.PI); 
    velX = 3.5 * (Math.sin(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI)); 
    velZ = 3.5 * (-1 * Math.cos(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI)); 
	
    bullet = Level.spawnMob(Player.getX() + Math.sin(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI) ,Player.getY()+1,Player.getZ() + -1 * Math.cos(getYaw() / 180 * Math.PI) * Math.cos((getPitch() - 180) / 180 * Math.PI) ,id);
   
    //Entity.setMobSkin(bullet, "bullet.png");
   
    setVelX(bullet,velX*1.2); 
    setVelY(bullet,velY*1.2); 
    setVelZ(bullet,velZ*1.2);
	
	}
	
	
	if(id == 65){
	Level.spawnMob(Player.getX() ,Player.getY()-2,Player.getZ() ,id);
	}
}






function loadFireButton(){

//Missile Code (Samueljh1) -- Please ask me to use this! (contact info at the top!)

var ctx = com.mojang.minecraftpe.MainActivity.currentMainActivity.get();
StartFov = 0;


AimOn = 0;
StartFov=1;

ctx.runOnUiThread(new java.lang.Runnable({

run:function(){

var ctx = com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

var layout=new android.widget.LinearLayout(ctx);
var layout2=new android.widget.LinearLayout(ctx);
layout2.setOrientation(android.widget.LinearLayout.VERTICAL);


var display=new android.util.DisplayMetrics();

w = ctx.getResources().getDisplayMetrics().widthPixels;
h = ctx.getResources().getDisplayMetrics().heightPixels;

window = new android.widget.PopupWindow();

btnWindow=new android.widget.PopupWindow(ctx);
btnWindow.setWidth(Math.ceil(150*ctx.getResources().getDisplayMetrics().density));//61
btnWindow.setHeight(Math.ceil(250*ctx.getResources().getDisplayMetrics().density));

btnWindow.setContentView(layout2);

btnWindow.setBackgroundDrawable(new android.graphics.drawable.ColorDrawable(android.graphics.Color.TRANSPARENT));
btnWindow.showAtLocation(ctx.getWindow().getDecorView(),android.view.Gravity.RIGHT|android.view.Gravity.BOTTOM,0,-50);


var firebtn=new android.widget.Button(ctx);
firebtn.setText("Fire");
firebtn.getBackground().setColorFilter(android.graphics.Color.RED,android.graphics.PorterDuff.Mode.MULTIPLY);
firebtn.setOnClickListener(new android.view.View.OnClickListener({

onClick:function(){

fireGun(80);



}}));


var bombbtn=new android.widget.Button(ctx);
bombbtn.setText("Drop Bomb");
bombbtn.getBackground().setColorFilter(android.graphics.Color.RED,android.graphics.PorterDuff.Mode.MULTIPLY);
bombbtn.setOnClickListener(new android.view.View.OnClickListener({

onClick:function(){

fireGun(65);



}}));



layout2.addView(firebtn);
layout2.addView(bombbtn);

}}));

}




function destroyFireButton(){

var ctx = com.mojang.minecraftpe.MainActivity.currentMainActivity.get();
StartFov = 0;


ctx.runOnUiThread(new java.lang.Runnable({

run:function(){

var ctx=com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

if(btnWindow !== null)
 btnWindow.dismiss();

}}));
}
function loadItems(){

clientMessage("§l§4Mech Mods by §bTDS200 §4and §bSamueljh1");

//Keys
ModPE.setItem(1000 , "key" , 0 , "Keys" );
Item.setCategory(1000,3);
Player.addItemCreativeInv(1000, 1);
Item.addShapedRecipe(1000, 1 , 0 , ["   "," i ","   "] , [ "i" , 265  , 0 ] );


//Fuel Can
ModPE.setItem(1001, "FuelCan" , 0 , "Fuel Can");
Item.setCategory(1001,3);
Player.addItemCreativeInv(1001, 1);
Item.addShapedRecipe(1001, 1 , 0 , ["  i"," cc"," cc"] , [ "i" , 265  , 0 , "c" , 263 , 0 ] );


//Engine
ModPE.setItem(1002 , "RotaryEngine" , 0 , "Engine");
Item.setCategory(1002,3);
Player.addItemCreativeInv(1002, 1);
Item.addShapedRecipe(1002, 1 , 0 , ["fif","iii","fif"] , [ "i" , 265  , 0 , "f" , 259 , 0 ] );


//large Wheel
ModPE.setItem( 1003 , "LargeWheel" , 0 , "Large Wheel");
Item.setCategory(1003,3);
Player.addItemCreativeInv(1003, 1);
Item.addShapedRecipe( 1003, 1 , 0 , [" l ","lil"," l "] , [ "i" , 265  , 0 , "l" , 334 , 0 ]  );


//Vehicle Chassis
ModPE.setItem( 1004 , "SmallCarChassis" , 0 , "Vehicle Chassis");
Item.setCategory(1004,3);
Player.addItemCreativeInv(1004, 1);
Item.addShapedRecipe( 1004, 1 , 0 , ["  g","ili","iii"] , [ "i" , 265  , 0 , "g" , 102 , 0 ,"l" , 334 , 0]  );


//Wooden Tail
ModPE.setItem( 1005 , "WoodenTail" , 0 , "Wooden Tail");
Item.setCategory(1005,3);
Player.addItemCreativeInv(1005, 1);
Item.addShapedRecipe( 1005, 1 , 0 , ["  p","ppp","  w"] , [ "w" , 1003  , 0 , "p" , 5 , 0 ] );


//Wooden Cockpit
ModPE.setItem( 1006 , "WoodenCockpit" , 0 , "Wooden Cockpit" );
Item.setCategory(1006,3);
Player.addItemCreativeInv(1006, 1);
Item.addShapedRecipe( 1006, 1 , 0 , ["   "," b ","w w"] , ["w" ,1003 , 0, "b" , 333  , 0] );


//Wooden Wing
ModPE.setItem( 1007 , "WoodenWing" , 0 , "Wooden Wing");
Item.setCategory(1007,3);
Player.addItemCreativeInv(1007, 1);
Item.addShapedRecipe( 1007, 1 , 0 , ["ppp","s s","ppp"] , [ "p" , 5  , 0 , "s" , 280 , 0 ]  );


//Metal Cockpit
ModPE.setItem( 1008 , "MetalCockpit" , 0 , "Metal Cockpit");
Item.setCategory(1008,3);
Player.addItemCreativeInv(1008, 1);
Item.addShapedRecipe(1008, 1 , 0 , [" g "," m ","w w"] , [ "m", 328, 0, "w" , 1003, 0, "g" , 102 , 0] );


//Metal Tail
ModPE.setItem(1009 , "MetalTail" , 0 , "Metal Tail" );
Item.setCategory(1009,3);
Player.addItemCreativeInv(1009, 1);
Item.addShapedRecipe(1009, 1 , 0 , ["  i","iii","  w"] , ["w" , 1003 , 0, "i" , 265 , 0]  );


//Metal Wing
ModPE.setItem(1010 , "MetalWingSmall" , 0 , "Metal Wing");
Item.setCategory(1010,3);
Player.addItemCreativeInv(1010, 1);
Item.addShapedRecipe(1010, 1 , 0 , ["iii","bbb","iii"] , [ "b", 101, 0, "i" , 265 , 0] );


//Cat Tracks
ModPE.setItem(1011 , "CatTrack" , 0 , "Cat Tracks");
Item.setCategory(1011,3);
Player.addItemCreativeInv(1011, 1);
Item.addShapedRecipe(1011, 1 , 0 , ["iii","wiw","iii"] , ["w", 1003, 0, "i" , 265 , 0] );


//Tank Body
ModPE.setItem(1012 , "TankBody" , 0 , "Tank Body");
Item.setCategory(1012,3);
Player.addItemCreativeInv(1012, 1);
Item.addShapedRecipe(1012, 1 , 0 , ["iti","iri","iii"] , ["r" , 331, 0, "t", 96 , 0, "i" , 265 , 0] );


//Tank Barrel
ModPE.setItem(1013 , "TankBarrel" , 0 , "Tank Barrel");
Item.setCategory(1013,3);
Player.addItemCreativeInv(1013, 1);
Item.addShapedRecipe(1013, 1 , 0 , ["  i","iii","  i"] , [ "i" , 265 , 0] );


//Tank Turret
ModPE.setItem(1014 , "TankTurret" , 0 , "Tank Turret");
Item.setCategory(1014,3);
Player.addItemCreativeInv(1014, 1);
Item.addShapedRecipe(1014, 1 , 0 , ["   ","bii"," ii"] , [ "b", 1013, 0, "i" , 265 , 0] );


//Wooden Prop
ModPE.setItem(1015 , "WoodenPropeller" , 0 , "Wooden Propeller");
Item.setCategory(1015,3);
Player.addItemCreativeInv(1015, 1);
Item.addShapedRecipe(1015, 1 , 0 , [" s "," i ","s s"] , [ "s", 280, 0, "i" , 265 , 0] );


//Metal Prop
ModPE.setItem(1016 , "MetalPropeller" , 0 , "Metal Propeller");
Item.setCategory(1016,3);
Player.addItemCreativeInv(1016, 1);
Item.addShapedRecipe(1016, 1 , 0 , [" i "," i ","i i"] , [ "i" , 265 , 0] );


//Bomb Bay
ModPE.setItem(1017 , "BombBay" , 0 , "Bomb Bay");
Item.setCategory(1017,3);
Player.addItemCreativeInv(1017, 1);
Item.addShapedRecipe(1017, 1 , 0 , ["iii","i i","iti"] , [ "t", 96 , 0, "i" , 265 , 0] );



for(i=0; i<vehicleBaseType.length; i++){
  if(vehicleBaseType[i] != null){
    vehicleBaseType[i].loadItems();
  }
}

}